﻿#target "indesign"
#targetengine "Ixta"

//	Copyright Dirk Becker
//	dirk (at) ixta.de
//	Usage:
//		Running the script will convert the selected guides into lines
//
//		Install as startup script, it add a menu item to the guides contextual folder.
//		- locate the "Scripts  Panel"folder
//		- the parent folder is called "Scripts"
//		- therein create the nested folders "Guides" then "Startup Scripts"
//		- move this script into "Scripts/Guides/Startup Scripts"
//		- restart InDesign

function getSelectedGuides()
{
	var ret = [];
	var sel = app.selection;
	for( var i=0; i<sel.length; i++ ) {
		var s=sel[i];
		if( s instanceof Guide )
		if( !s.locked )
			ret.push(s);
	}
	return ret;
}

function beforeGuidesToLines(e)
{
	e.target.enabled = getSelectedGuides().length>0;
}

function invokeGuidesToLines()
{
	var guides = getSelectedGuides();
	for( var i=0; i<guides.length; i++ ) {
		var g = guides[i];
		var spread = g.parent.parent;
		var lpage = spread.pages.firstItem();
		var rpage = spread.pages.lastItem();
		var xy = g.location;
		if( g.orientation==HorizontalOrVertical.HORIZONTAL ) {
			var b = [ xy, lpage.bounds[1]-10, xy, rpage.bounds[3]+10 ];
		} else {
			var b = [ lpage.bounds[0]-2, xy, rpage.bounds[2]+2, xy ];
		}
		spread.graphicLines.add(g.itemLayer,
			LocationOptions.AT_BEGINNING,null,
			{geometricBounds: b});
		g.remove();
	}
}

function install()
{
	var menu = app.menus.itemByName("$ID/RtMouseGuide");
	var name = "Guides to Lines";
	try {
		var mi = menu.menuItems.itemByName(name);
		var ma = mi.associatedMenuAction;
		mi.remove();
		ma.remove();
	} catch (ex) {}
	ma = app.scriptMenuActions.add({name: name});
	ma.eventListeners.add("beforeDisplay",beforeGuidesToLines,false);
	ma.eventListeners.add("onInvoke",invokeGuidesToLines,false);
	mi = menu.menuItems.add({
		associatedMenuAction: ma,name: name,title: name});
}

if( $.engineName=="Ixta" )
	install();
else
	invokeGuidesToLines();
